#include <dos.h>
#include <conio.h>
#include <fstream.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned char UCHAR;
typedef unsigned int UINT;

struct PCX_Header
{
	char manufacturer;
	char version;
	char encoding;
	char bits_per_pixel;
	int x,y;
	int width,height;
	int horz_res;
	int vert_res;
	char ega_palette[48];
	char reserved;
	char num_color_planes;
	int bytes_per_line;
	int palette_type;
	char padding[58];
};

typedef struct PCX_Picture
{
	struct PCX_Header header;
	unsigned char r[256];
	unsigned char g[256];
	unsigned char b[256];
	unsigned char far *buffer;
} PCX_Picture;

// SET MODE FUNCTIONS
void SetVGA();
void SetTXT();
void SetMode(int mode);

// GRAPHICS PRIMITIVES
void PutPixel(int x, int y, int color);
int GetPixel(int x, int y);
void HorizLine(int x, int x2, int y, int color);
void VertLine(int x, int y, int y2, int color);

// PALETTE FUNCTIONS
void SetPal(int colornum, int red, int green, int blue);
void GetPal(int colornum, UCHAR* red, UCHAR* green, UCHAR* blue);
void RotatePal(int start, int end, int num, int dir);
void GrabPal(unsigned char pal[]);
void BlackOutPal();
void FadeOut();
void FadeIn(unsigned char pal[]);

// SPRITE FUNCTIONS
void PutBitmap(int bitmap[], int x, int y);
void PutBitmapT(int bitmap[], int x, int y);
void CutOut(int bitmap[], int x, int y);
void SaveBitmap(int bitmap[], char* filename);
void LoadBitmap(int* bitmap[], char* filename);

// MISCELLANEOUS FUNCTIONS
void WaitRetrace();

// KEYBOARD FUNCTIONS
int CheckKey(int key);

// MOUSE FUNCTIONS
void InitMouse();
void ShowMouse();
void HideMouse();
int GetMouseX();
int GetMouseY();
int TXTGetMouseX();
int TXTGetMouseY();
int MGetStat();

// PCX FUNCTIONS
void LoadPCX(char *filename, struct PCX_Picture *image, int setpal);
void ShowPCX(struct PCX_Picture image, int x, int y);
void SetPCXPal(struct PCX_Picture image);
void FreePCX(struct PCX_Picture *pcx);

// SPECIAL EFFECTS
void BlackOutDot();
void BlackOutLine(int delayms, int type);
void BlackSweep(int direction, int type, int delayms);


